package com.lantone.qc.trans.shaoyf;

import com.google.common.collect.Lists;
import com.lantone.qc.dbanaly.facade.shaoyf.ShaoyfXmlUtil;
import com.lantone.qc.pub.model.doc.ReasonableDiagnosisDoc;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.trans.ModelDocTrans;
import com.lantone.qc.trans.comsis.OrdinaryAssistant;

import java.util.List;
import java.util.Map;

/**
 * @Description: 诊疗合理性文档生成
 * @author: rengb
 * @time: 2020/3/17 13:27
 */
public class ShaoyfReasonableDiagnosisDocTrans extends ModelDocTrans {

    @Override
    public List<ReasonableDiagnosisDoc> extract(MedrecVo medrecVo) {
        List<ReasonableDiagnosisDoc> retList = Lists.newArrayList();
        List<Map<String, Object>> contentMaps = (List) medrecVo.getContent().get("content");
        contentMaps.forEach(contentMap -> {
            retList.add(getReasonableDiagnosisDoc(contentMap));
        });
        return retList;
    }

    private ReasonableDiagnosisDoc getReasonableDiagnosisDoc(Map<String, Object> contentMap) {
        String content = contentMap.get("xmlText").toString();
        Map<String, String> sourceMap = ShaoyfXmlUtil.getXmlToMap(content);
        sourceMap.put("mode_id=" + contentMap.get("modeId").toString(), "");
        sourceMap.put("rec_title=" + contentMap.get("recTitle").toString(), "");
        Map<String, String> structureMap = OrdinaryAssistant.mapKeyContrast(sourceMap, keyContrasts);

        ReasonableDiagnosisDoc reasonableDiagnosisDoc = new ReasonableDiagnosisDoc();
        reasonableDiagnosisDoc.setStructureMap(structureMap);

        return reasonableDiagnosisDoc;
    }

    private List<String> keyContrasts = Lists.newArrayList();

}